﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;

namespace ketpaneles_meroprogram
{
    public partial class Form1 : Form
    {
        bool Run = false;
        StreamWriter fileWriter;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            chart1.ChartAreas[0].AxisX.Title = "Time (sec)";
            chart1.ChartAreas[0].AxisY.Title = "Amplitude (V)";

            chart1.ChartAreas[0].AxisX.LabelStyle.Format = "0.##";
            chart1.ChartAreas[0].AxisY.LabelStyle.Format = "0.##";

            chart1.Legends[0].Docking = Docking.Top;

            chart1.Series[0].ChartType = SeriesChartType.Line;

            chart2.ChartAreas[0].AxisX.Title = "Time (sec)";
            chart2.ChartAreas[0].AxisY.Title = "Amplitude (V)";

            chart2.ChartAreas[0].AxisX.LabelStyle.Format = "0.##";
            chart2.ChartAreas[0].AxisY.LabelStyle.Format = "0.##";

            chart2.Legends[0].Docking = Docking.Top;

            chart2.Series[0].ChartType = SeriesChartType.Line;
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            if (Run)
            {
                timer.Enabled = false;
                Run = false;
                buttonStart.Text = "Start";
                fileWriter.Close();
            }
            else
            {
                saveFileDialog.ShowDialog();
            }
        }

        private void saveFileDialog_FileOk(object sender, CancelEventArgs e)
        {
            fileWriter = new StreamWriter(saveFileDialog.FileName);
            timer.Interval = Convert.ToInt32(numericInterval.Value);
            Run = true;
            buttonStart.Text = "Stop";
            timer.Enabled = true;
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            double x, y;

            // mérés
            x = 0;
            y = 0;

            // adatok mentése file-ba
            fileWriter.WriteLine(Convert.ToString(x) + "\t" + Convert.ToString(y));
        }

        private void Chart1ScaleChanged(object sender, EventArgs e)
        {
            if (Chart1AutoScale.Checked)
            {
                chart1.ChartAreas[0].AxisX.Minimum = Double.NaN;
                chart1.ChartAreas[0].AxisX.Maximum = Double.NaN;
                chart1.ChartAreas[0].AxisY.Minimum = Double.NaN;
                chart1.ChartAreas[0].AxisY.Maximum = Double.NaN;
            }
            else
            {
                chart1.ChartAreas[0].AxisX.Minimum = Convert.ToDouble(numericChart1XMin.Value);
                chart1.ChartAreas[0].AxisX.Maximum = Convert.ToDouble(numericChart1XMax.Value);
                chart1.ChartAreas[0].AxisY.Minimum = Convert.ToDouble(numericChart1YMin.Value);
                chart1.ChartAreas[0].AxisY.Maximum = Convert.ToDouble(numericChart1YMax.Value);
            }
        }

        private void Chart2ScaleChanged(object sender, EventArgs e)
        {
            if (Chart2AutoScale.Checked)
            {
                chart2.ChartAreas[0].AxisX.Minimum = Double.NaN;
                chart2.ChartAreas[0].AxisX.Maximum = Double.NaN;
                chart2.ChartAreas[0].AxisY.Minimum = Double.NaN;
                chart2.ChartAreas[0].AxisY.Maximum = Double.NaN;
            }
            else
            {
                chart2.ChartAreas[0].AxisX.Minimum = Convert.ToDouble(numericChart2XMin.Value);
                chart2.ChartAreas[0].AxisX.Maximum = Convert.ToDouble(numericChart2XMax.Value);
                chart2.ChartAreas[0].AxisY.Minimum = Convert.ToDouble(numericChart2YMin.Value);
                chart2.ChartAreas[0].AxisY.Maximum = Convert.ToDouble(numericChart2YMax.Value);
            }
        }

        private void buttonGetData_Click(object sender, EventArgs e)
        {
            int numPnts = chart1.Series[0].Points.Count;
            for (int i = 0; i < numPnts; i++)
            {
                DataPoint P = chart1.Series[0].Points.ElementAt(i);
                double x = P.XValue;
                double y = P.YValues[0];
            }
        }

        private void buttonClear1_Click(object sender, EventArgs e)
        {
            chart1.Series[0].Points.Clear();
        }

        private void buttonClear2_Click(object sender, EventArgs e)
        {
            chart2.Series[0].Points.Clear();
        }

    }
}
